/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataGithubOrganizationCustomRoleConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/integrations/github/5.39.0/docs/data-sources/organization_custom_role#id DataGithubOrganizationCustomRole#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/integrations/github/5.39.0/docs/data-sources/organization_custom_role#name DataGithubOrganizationCustomRole#name}
    */
    readonly name: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/integrations/github/5.39.0/docs/data-sources/organization_custom_role github_organization_custom_role}
*/
export declare class DataGithubOrganizationCustomRole extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "github_organization_custom_role";
    /**
    * Create a new {@link https://registry.terraform.io/providers/integrations/github/5.39.0/docs/data-sources/organization_custom_role github_organization_custom_role} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataGithubOrganizationCustomRoleConfig
    */
    constructor(scope: Construct, id: string, config: DataGithubOrganizationCustomRoleConfig);
    get baseRole(): string;
    get description(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get permissions(): string[];
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
